Runtime (Velocity 1.7 API)
Keywords: org.apache.velocity.runtime.Runtime class

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.velocity.runtime
Class Runtime

    java.lang.Object
      org.apache.velocity.runtime.Runtime

All Implemented Interfaces:
  RuntimeConstants

Deprecated. Use RuntimeInstance or RuntimeSingleton instead.

public class Runtime
extends Object
implements RuntimeConstants

This is the Runtime system for Velocity. It is the single access point for all functionality in Velocity. It adheres to the mediator pattern and is the only structure that developers need to be familiar with in order to get Velocity to perform. The Runtime will also cooperate with external systems like Turbine. Runtime properties can set and then the Runtime is initialized. Turbine for example knows where the templates are to be loaded from, and where the velocity log file should be placed. So in the case of Velocity cooperating with Turbine the code might look something like the following:

     Runtime.setProperty(Runtime.FILE_RESOURCE_LOADER_PATH, templatePath);
     Runtime.setProperty(Runtime.RUNTIME_LOG, pathToVelocityLog);
     Runtime.init();

     -----------------------------------------------------------------------
     N O T E S  O N  R U N T I M E  I N I T I A L I Z A T I O N
     -----------------------------------------------------------------------
     Runtime.init()

     If Runtime.init() is called by itself the Runtime will
     initialize with a set of default values.
     -----------------------------------------------------------------------
     Runtime.init(String/Properties)

     In this case the default velocity properties are layed down
     first to provide a solid base, then any properties provided
     in the given properties object will override the corresponding
     default property.
     -----------------------------------------------------------------------

Version:
  $Id: Runtime.java 685390 2008-08-13 00:07:23Z nbubna $
Author:
  Jason van Zyl, Jeff Bowden, Geir Magusson Jr.
See Also:
  `RuntimeInstance`, `RuntimeSingleton`

Field Summary

Fields inherited from interface org.apache.velocity.runtime.RuntimeConstants
`COUNTER_INITIAL_VALUE, COUNTER_NAME, DEBUG_PREFIX, DEFAULT_RUNTIME_DIRECTIVES, DEFAULT_RUNTIME_PROPERTIES, DEFINE_DIRECTIVE_MAXDEPTH, DIRECTIVE_IF_TOSTRING_NULLCHECK, ENCODING_DEFAULT, ERROR_PREFIX, ERRORMSG_END, ERRORMSG_START, EVALUATE_CONTEXT_CLASS, EVENTHANDLER_INCLUDE, EVENTHANDLER_INVALIDREFERENCES, EVENTHANDLER_METHODEXCEPTION, EVENTHANDLER_NULLSET, EVENTHANDLER_REFERENCEINSERTION, FILE_RESOURCE_LOADER_CACHE, FILE_RESOURCE_LOADER_PATH, HAS_NEXT_NAME, INFO_PREFIX, INPUT_ENCODING, INTERPOLATE_STRINGLITERALS, INTROSPECTOR_RESTRICT_CLASSES, INTROSPECTOR_RESTRICT_PACKAGES, MAX_NUMBER_LOOPS, NUMBER_OF_PARSERS, OUTPUT_ENCODING, PARSE_DIRECTIVE_MAXDEPTH, PARSER_POOL_CLASS, PARSER_POOL_SIZE, PROVIDE_SCOPE_CONTROL, RESOURCE_LOADER, RESOURCE_MANAGER_CACHE_CLASS, RESOURCE_MANAGER_CLASS, RESOURCE_MANAGER_DEFAULTCACHE_SIZE, RESOURCE_MANAGER_LOGWHENFOUND, RUNTIME_LOG, RUNTIME_LOG_ERROR_STACKTRACE, RUNTIME_LOG_INFO_STACKTRACE, RUNTIME_LOG_LOGSYSTEM, RUNTIME_LOG_LOGSYSTEM_CLASS, RUNTIME_LOG_REFERENCE_LOG_INVALID, RUNTIME_LOG_WARN_STACKTRACE, RUNTIME_REFERENCES_STRICT, RUNTIME_REFERENCES_STRICT_ESCAPE, SET_NULL_ALLOWED, SKIP_INVALID_ITERATOR, STRICT_MATH, TRACE_PREFIX, UBERSPECT_CLASSNAME, UNKNOWN_PREFIX, VM_ARGUMENTS_STRICT, VM_BODY_REFERENCE, VM_CONTEXT_LOCALSCOPE, VM_LIBRARY, VM_LIBRARY_AUTORELOAD, VM_LIBRARY_DEFAULT, VM_MAX_DEPTH, VM_MESSAGES_ON, VM_PERM_ALLOW_INLINE, VM_PERM_ALLOW_INLINE_REPLACE_GLOBAL, VM_PERM_INLINE_LOCAL, WARN_PREFIX`

Constructor Summary
`Runtime()` Deprecated.

Method Summary
`static void` | `addProperty(String key, Object value)` Deprecated. Add a property to the configuration.
`static boolean` | `addVelocimacro(String name, String macro, String[] argArray, String sourceTemplate)` Deprecated. Just like the whole class....
`static void` | `clearProperty(String key)` Deprecated. Clear the values pertaining to a particular property.
`static void` | `debug(Object message)` Deprecated. Log a debug message.
`static boolean` | `dumpVMNamespace(String namespace)` Deprecated. tells the vmFactory to dump the specified namespace.
`static void` | `error(Object message)` Deprecated. Log an error message.
`static boolean` | `getBoolean(String key, boolean def)` Deprecated. Boolean property accessor method to hide the configuration implementation.
`static ExtendedProperties` | `getConfiguration()` Deprecated. Return the velocity runtime configuration object.
`static ContentResource` | `getContent(String name)` Deprecated. Returns a static content resource from the resource manager.
`static ContentResource` | `getContent(String name, String encoding)` Deprecated. Returns a static content resource from the resource manager.
`static int` | `getInt(String key)` Deprecated. Int property accessor method to hide the configuration implementation.
`static int` | `getInt(String key, int defaultValue)` Deprecated. Int property accessor method to hide the configuration implementation.
`static String` | `getLoaderNameForResource(String resourceName)` Deprecated. Determines is a template exists, and returns name of the loader that provides it.
`static Object` | `getProperty(String key)` Deprecated. Allows an external caller to get a property.
`static String` | `getString(String key)` Deprecated. String property accessor method to hide the configuration implementation
`static String` | `getString(String key, String defaultValue)` Deprecated. String property accessor method with default to hide the configuration implementation.
`static Template` | `getTemplate(String name)` Deprecated. Returns a `Template` from the resource manager.
`static Template` | `getTemplate(String name, String encoding)` Deprecated. Returns a `Template` from the resource manager
`static Directive` | `getVelocimacro(String vmName, String templateName)` Deprecated. Returns the appropriate VelocimacroProxy object if strVMname is a valid current Velocimacro.
`static void` | `info(Object message)` Deprecated. Log an info message.
`static void` | `init()` Deprecated. This is the primary initialization method in the Velocity Runtime.
`static void` | `init(Properties p)` Deprecated. Initialize the Velocity Runtime with a Properties object.
`static void` | `init(String configurationFile)` Deprecated. Initialize the Velocity Runtime with the name of ExtendedProperties object.
`static boolean` | `isVelocimacro(String vmName, String templateName)` Deprecated. Checks to see if a VM exists
`static SimpleNode` | `parse(Reader reader, String templateName)` Deprecated. Parse the input and return the root of AST node structure.
`static SimpleNode` | `parse(Reader reader, String templateName, boolean dumpNamespace)` Deprecated. Parse the input and return the root of the AST node structure.
`static void` | `setConfiguration(ExtendedProperties configuration)` Deprecated. Allow an external system to set an ExtendedProperties object to use.
`static void` | `setProperty(String key, Object value)` Deprecated. Allows an external system to set a property in the Velocity Runtime.
`static void` | `warn(Object message)` Deprecated. Log a warning message.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### Runtime

    public Runtime()

  Deprecated.

Method Detail

### init

    public static void init()
                     throws Exception

  Deprecated.
  This is the primary initialization method in the Velocity Runtime. The systems that are setup/initialized here are as follows:
  - Logging System
  - ResourceManager
  - Parser Pool
  - Global Cache
  - Static Content Include System
  - Velocimacro System

  Throws:
    `Exception` - When init fails for any reason.

### setProperty

    public static void setProperty(String key,
                                   Object value)

  Deprecated.
  Allows an external system to set a property in the Velocity Runtime.

  Parameters:
    `key` - The property key.
    `value` - The property value.

### setConfiguration

    public static void setConfiguration(ExtendedProperties configuration)

  Deprecated.
  Allow an external system to set an ExtendedProperties object to use. This is useful where the external system also uses the ExtendedProperties class and the velocity configuration is a subset of parent application's configuration. This is the case with Turbine.

  Parameters:
    `configuration` - A configuration object.

### addProperty

    public static void addProperty(String key,
                                   Object value)

  Deprecated.
  Add a property to the configuration. If it already exists then the value stated here will be added to the configuration entry. For example, if resource.loader = file is already present in the configuration and you addProperty("resource.loader", "classpath") Then you will end up with a Vector like the following: ["file", "classpath"]

  Parameters:
    `key` - A property key.
    `value` - The property value.

### clearProperty

    public static void clearProperty(String key)

  Deprecated.
  Clear the values pertaining to a particular property.

  Parameters:
    `key` - Name of the property to clear.

### getProperty

    public static Object getProperty(String key)

  Deprecated.
  Allows an external caller to get a property. The calling routine is required to know the type, as this routine will return an Object, as that is what properties can be.

  Parameters:
    `key` - property to return
  Returns:
    The property value or null.

### init

    public static void init(Properties p)
                     throws Exception

  Deprecated.
  Initialize the Velocity Runtime with a Properties object.

  Parameters:
    `p` - The properties used for initializiation.
  Throws:
    `Exception` - When a problem occurs during init.

### init

    public static void init(String configurationFile)
                     throws Exception

  Deprecated.
  Initialize the Velocity Runtime with the name of ExtendedProperties object.

  Parameters:
    `configurationFile` - The name of a properties file.
  Throws:
    `Exception` - When a problem occurs during init.

### parse

    public static SimpleNode parse(Reader reader,
                                   String templateName)
                            throws ParseException

  Deprecated.
  Parse the input and return the root of AST node structure.
  In the event that it runs out of parsers in the pool, it will create and let them be GC'd dynamically, logging that it has to do that. This is considered an exceptional condition. It is expected that the user will set the PARSER_POOL_SIZE property appropriately for their application. We will revisit this.

  Parameters:
    `reader` - A reader returning the template input stream.
    `templateName` - name of the template being parsed
  Returns:
    The root node of an AST structure for the template input stream.
  Throws:
    `ParseException` - When the input stream is not parsable.

### parse

    public static SimpleNode parse(Reader reader,
                                   String templateName,
                                   boolean dumpNamespace)
                            throws ParseException

  Deprecated.
  Parse the input and return the root of the AST node structure.

  Parameters:
    `reader` - A reader returning the template input stream.
    `templateName` - name of the template being parsed
    `dumpNamespace` - flag to dump the Velocimacro namespace for this template.
  Returns:
    The root node of an AST structure for the template input stream.
  Throws:
    `ParseException` - When the input stream is not parsable.
  See Also:
    `parse(Reader, String)`

### getTemplate

    public static Template getTemplate(String name)
                                throws ResourceNotFoundException,
                                       ParseErrorException,
                                       Exception

  Deprecated.
  Returns a `Template` from the resource manager. This method assumes that the character encoding of the template is set by the `input.encoding` property. The default is "ISO-8859-1"

  Parameters:
    `name` - The file name of the desired template.
  Returns:
    The template.
  Throws:
    `ResourceNotFoundException` - if template not found from any available source.
    `ParseErrorException` - if template cannot be parsed due to syntax (or other) error.
    `Exception` - if an error occurs in template initialization.

### getTemplate

    public static Template getTemplate(String name,
                                       String encoding)
                                throws ResourceNotFoundException,
                                       ParseErrorException,
                                       Exception

  Deprecated.
  Returns a `Template` from the resource manager

  Parameters:
    `name` - The name of the desired template.
    `encoding` - Character encoding of the template
  Returns:
    The template.
  Throws:
    `ResourceNotFoundException` - if template not found from any available source.
    `ParseErrorException` - if template cannot be parsed due to syntax (or other) error.
    `Exception` - if an error occurs in template initialization

### getContent

    public static ContentResource getContent(String name)
                                      throws ResourceNotFoundException,
                                             ParseErrorException,
                                             Exception

  Deprecated.
  Returns a static content resource from the resource manager. Uses the current value if INPUT_ENCODING as the character encoding.

  Parameters:
    `name` - Name of content resource to get
  Returns:
    parsed ContentResource object ready for use
  Throws:
    `ResourceNotFoundException` - if template not found from any available source.
    `ParseErrorException` - if template cannot be parsed due to syntax (or other) error.
    `Exception` - if an error occurs in template initialization

### getContent

    public static ContentResource getContent(String name,
                                             String encoding)
                                      throws ResourceNotFoundException,
                                             ParseErrorException,
                                             Exception

  Deprecated.
  Returns a static content resource from the resource manager.

  Parameters:
    `name` - Name of content resource to get
    `encoding` - Character encoding to use
  Returns:
    parsed ContentResource object ready for use
  Throws:
    `ResourceNotFoundException` - if template not found from any available source.
    `ParseErrorException` - if template cannot be parsed due to syntax (or other) error.
    `Exception` - if an error occurs in template initialization

### getLoaderNameForResource

    public static String getLoaderNameForResource(String resourceName)

  Deprecated.
  Determines is a template exists, and returns name of the loader that provides it. This is a slightly less hokey way to support the Velocity.templateExists() utility method, which was broken when per-template encoding was introduced. We can revisit this.

  Parameters:
    `resourceName` - Name of template or content resource
  Returns:
    class name of loader than can provide it

### warn

    public static void warn(Object message)

  Deprecated.
  Log a warning message.

  Parameters:
    `message` - message to log

### info

    public static void info(Object message)

  Deprecated.
  Log an info message.

  Parameters:
    `message` - message to log

### error

    public static void error(Object message)

  Deprecated.
  Log an error message.

  Parameters:
    `message` - message to log

### debug

    public static void debug(Object message)

  Deprecated.
  Log a debug message.

  Parameters:
    `message` - message to log

### getString

    public static String getString(String key,
                                   String defaultValue)

  Deprecated.
  String property accessor method with default to hide the configuration implementation.

  Parameters:
    `key` - A property key.
    `defaultValue` - default value to return if key not found in resource manager.
  Returns:
    The property value of of key or default.

### getVelocimacro

    public static Directive getVelocimacro(String vmName,
                                           String templateName)

  Deprecated.
  Returns the appropriate VelocimacroProxy object if strVMname is a valid current Velocimacro.

  Parameters:
    `vmName` - Name of velocimacro requested
    `templateName` - The template from which the macro is requested.
  Returns:
    A VelocimacroProxy object for the macro.

### addVelocimacro

    public static boolean addVelocimacro(String name,
                                         String macro,
                                         String[] argArray,
                                         String sourceTemplate)

  Deprecated. Just like the whole class....

  Adds a new Velocimacro. Usually called by Macro only while parsing.

  Parameters:
    `name` - Name of a new velocimacro.
    `macro` - String form of the macro body.
    `argArray` - Array of strings, containing the #macro() arguments. the 0th argument is the name.
    `sourceTemplate` - The template from which the macro is requested.
  Returns:
    boolean True if added, false if rejected for some reason (either parameters or permission settings)

### isVelocimacro

    public static boolean isVelocimacro(String vmName,
                                        String templateName)

  Deprecated.
  Checks to see if a VM exists

  Parameters:
    `vmName` - The name of velocimacro.
    `templateName` - The template from which the macro is requested.
  Returns:
    boolean True if VM by that name exists, false if not

### dumpVMNamespace

    public static boolean dumpVMNamespace(String namespace)

  Deprecated.
  tells the vmFactory to dump the specified namespace. This is to support clearing the VM list when in inline-VM-local-scope mode

  Parameters:
    `namespace` - The namespace to dump.
  Returns:
    True if the namespace has been dumped.

### getString

    public static String getString(String key)

  Deprecated.
  String property accessor method to hide the configuration implementation

  Parameters:
    `key` - property key
  Returns:
    value of key or null

### getInt

    public static int getInt(String key)

  Deprecated.
  Int property accessor method to hide the configuration implementation.

  Parameters:
    `key` - A property key.
  Returns:
    Integer value for this key.

### getInt

    public static int getInt(String key,
                             int defaultValue)

  Deprecated.
  Int property accessor method to hide the configuration implementation.

  Parameters:
    `key` - property key
    `defaultValue` - default value
  Returns:
    The integer value.

### getBoolean

    public static boolean getBoolean(String key,
                                     boolean def)

  Deprecated.
  Boolean property accessor method to hide the configuration implementation.

  Parameters:
    `key` - property key
    `def` - default default value if property not found
  Returns:
    boolean value of key or default value

### getConfiguration

    public static ExtendedProperties getConfiguration()

  Deprecated.
  Return the velocity runtime configuration object.

  Returns:
    ExtendedProperties configuration object which houses the velocity runtime properties.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000-2010 Apache Software Foundation. All Rights Reserved.